# GStreamer documentation

Feel free to jump straight to the download section, start practicing
with the tutorials, or read the F.A.Q. if you don’t know what this is
all about.



## General

 * [Application Development Manual (Read this first)](application-development/index.md)
 * <a href="/data/doc/gstreamer/head/faq/html/index.html">Frequently Asked Questions</a>
 * [](pwg/index.md)
 * <a href="/data/doc/gstreamer/head/gstreamer/html/">Core Reference</a>
 * <a href="/data/doc/gstreamer/head/gstreamer-libs/html/">Core Libraries Reference/a>
 * [Core Design Documentation](http://cgit.freedesktop.org/gstreamer/gstreamer/tree/docs/design/)
 * [GStreamer 0.10 to 1.0 porting guide](http://cgit.freedesktop.org/gstreamer/gstreamer/plain/docs/random/porting-to-1.0.txt)

<!-- FIXME: save useful bits from wiki
| GStreamer Wiki (see esp. <a href="&site;/wiki/ReleasePlanning">ReleasePlanning</a> and <a href="&site;/wiki/SubmittingPatches">SubmittingPatches</a>)
| <a href="&site;/wiki/">HTML</a> |
-->


## GStreamer Plugins-Base Module Libraries Reference

 * <a href="/data/doc/gstreamer/head/gst-plugins-base-libs/html/">GStreamer Base Plugins Libraries Reference</a>

## GStreamer Plugins-Bad Module Libraries Reference

Note: The API from these gst-plugins-bad libraries is unstable and can
change between releases.

Only the API in libraries from GStreamer core and
gst-plugins-base are guaranteed to be API and ABI stable

 * <a href="/data/doc/gstreamer/head/gst-plugins-bad-libs/html/">GStreamer Bad Plugins Libraries Reference</a>

## Plugin Modules

 * <a href="plugins.html">Overview of all Plug-ins</a>
 * <a href="/data/doc/gstreamer/head/gstreamer-plugins/html/">GStreamer Core Plugins Reference</a>
 * <a href="/data/doc/gstreamer/head/gst-plugins-base-plugins/html/">GStreamer Base Plugins Reference</a>
 * <a href="/data/doc/gstreamer/head/gst-plugins-good-plugins/html/">GStreamer Good Plugins Reference</a>
 * <a href="/data/doc/gstreamer/head/gst-plugins-ugly-plugins/html/">GStreamer Ugly Plugins Reference</a>
 * <a href="/data/doc/gstreamer/head/gst-plugins-bad-plugins/html/">GStreamer Bad Plugins Reference</a>

## Other modules

 * <a href="/data/doc/gstreamer/head/gstreamer-editing-services/html/">GStreamer Editing Services Reference</a>
 * <a href="/data/doc/gstreamer/head/gst-rtsp-server/html/">GStreamer RTSP Server Reference</a>
 * <a href="/data/doc/gstreamer/head/gstreamer-vaapi-plugins/html/">GStreamer VAAPI Reference</a>
 * <a href="/data/doc/gstreamer/head/qt-gstreamer/html/">QtGStreamer Reference</a>
 * <a href="/data/doc/gstreamer/head/gst-validate/html/">GstValidate Reference</a>
 * <a href="/data/doc/orc/">Orc - Optimized inner loop Runtime Compiler</a>
 * <a href="/data/doc/gstreamer/head/gnonlin/html/">GStreamer Non-Linear Multimedia Editing Plugins Reference (deprecated, use GStreamer Editing Services instead)</a>

## GStreamer Conference Videos and Slides

* <a href="http://gstconf.ubicast.tv/channels/#gstreamer-conference-2015">GStreamer Conference 2015: Videos and Slides</a> <a href="/data/events/gstreamer-conference/2015/">(PDF slides)</a>
 * <a href="http://gstconf.ubicast.tv/channels/#gstreamer-conference-2014">GStreamer Conference 2014: Videos and Slides</a> <a href="/data/events/gstreamer-conference/2014/">(PDF slides)</a>
 * <a href="http://gstconf.ubicast.tv/channels/#gstreamer-conference-2013">GStreamer Conference 2013: Videos and Slides</a> <a href="/data/events/gstreamer-conference/2013/">(PDF slides)</a>
 * <a href="http://gstconf.ubicast.tv/channels/#gstreamer-conference-2012">GStreamer Conference 2012: Videos and Slides</a> <a href="/data/events/gstreamer-conference/2012/">(PDF slides)</a>
 * <a href="http://gstconf.ubicast.tv/channels/#conferences-2011">GStreamer Conference 2011: Videos and Slides</a> <a href="/data/events/gstreamer-conference/2011/">(PDF slides)</a>
* <a href="http://gstconf.ubicast.tv/channels/#conferences-2010">GStreamer Conference 2010: Videos and Slides</a> <a href="/data/events/gstreamer-conference/2010/">(PDF slides)</a>


## GStreamer licensing advisory

The GStreamer community provides the following licensing advisory for
developers planing on or already using GStreamer for their applications:

 * <a href="/documentation/licensing.html">GStreamer Licensing Advisory</a>


## GStreamer plugin module split-up

[An explanation of the various plugin modules and how they were split up](splitup.md)

## RTP and RTSP support in GStreamer

 * [RTSP and RTP component overview](rtp.md)
